﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.IO;

public partial class profile : System.Web.UI.Page
{
    SqlConnection con = new SqlConnection(@"Data Source=.\SQLEXPRESS;AttachDbFilename=|DataDirectory|\Database.mdf;Integrated Security=True;User Instance=True");
    SqlCommand cmd = new SqlCommand();

    protected void Page_Load(object sender, EventArgs e)
    {
        //check user is logged in
        chkCookie();

        //check edit mode
        chkEditMode();

        con.Open();
        ChangeTitle();

        if (!chkProfile(Convert.ToInt32(Request.Cookies["id"].Value)))
        {
            cmd.Connection = con;
            cmd.CommandText = "insert [profile](id,avatar) values(@id,'avatar.png')";
            cmd.ExecuteNonQuery();
        }

        SetAvatar();
    }
    //********************************************************
    protected void Page_PreRender()
    {
        cmd.Connection = con;

        //set birthday
        cmd.CommandText = "select count(*) from [profile] where id=@id and birthday like '%/%'";

        if (cmd.ExecuteScalar().ToString() == "1")
        {
            ddlDate_Set();
            SetBirthday();
        }
        else
            ddlDate_Set();

        //set country
        cmd.CommandText = "select country from [profile] where id=@id";

        if (cmd.ExecuteScalar().ToString() != "")
            txtCountry.Text = cmd.ExecuteScalar().ToString();

        //set city
        cmd.CommandText = "select city from [profile] where id=@id";

        if (cmd.ExecuteScalar().ToString() != "")
            txtCity.Text = cmd.ExecuteScalar().ToString();

        //set about
        cmd.CommandText = "select about from [profile] where id=@id";

        if (cmd.ExecuteScalar().ToString() != "")
            txtAbout.Text = cmd.ExecuteScalar().ToString();

        //set sex
        cmd.CommandText = "select sex from [profile] where id=@id";

        if (cmd.ExecuteScalar().ToString() != "")
        {
            if (cmd.ExecuteScalar().ToString() == "True")
                rdbSex.SelectedIndex = 0;
            else if (cmd.ExecuteScalar().ToString() == "False")
                rdbSex.SelectedIndex = 1;
        }

        //set M
        cmd.CommandText = "select m from [profile] where id=@id";

        if (cmd.ExecuteScalar().ToString() != "")
        {
            if (cmd.ExecuteScalar().ToString() == "True")
                rdbM.SelectedIndex = 1;
            else if (cmd.ExecuteScalar().ToString() == "False")
                rdbM.SelectedIndex = 0;
        }
    }
    //********************************************************
    void ChangeTitle()
    {
        cmd.Connection = con;
        cmd.CommandText = "select name from [users] where id = @id";
        cmd.Parameters.AddWithValue("@id", Convert.ToInt32(Request.Cookies["id"].Value));
        ltlTitile.Text = cmd.ExecuteScalar().ToString();
        ltlTitile.Text += " - Status";
    }
    //********************************************************
    void chkEditMode()
    {
        try
        {
            string mode = Request.QueryString["mode"].ToString();

            if (mode == "pic")
            {
                pnlEditProfile.Visible = false;
                pnlChangeAvatar.Visible = true;
            }
            else if (mode == "all")
            {
                pnlEditProfile.Visible = true;
                pnlChangeAvatar.Visible = false;
            }
        }
        catch
        {
            Response.Redirect("~/home.aspx");
        }
    }
    //********************************************************
    void ddlDate_Set()
    {
        ddlYear.Items.Clear();
        ddlMonth.Items.Clear();
        ddlDay.Items.Clear();

        for (int i = 2014; i >= 1904; i--)
            ddlYear.Items.Add(i.ToString());

        for(int i=1 ; i<=31; i++)
            ddlDay.Items.Add(i.ToString());

        ddlMonth.Items.Add("jan");
        ddlMonth.Items.Add("Feb");
        ddlMonth.Items.Add("Mar");
        ddlMonth.Items.Add("Apr");
        ddlMonth.Items.Add("May");
        ddlMonth.Items.Add("Jun");
        ddlMonth.Items.Add("Jul");
        ddlMonth.Items.Add("Aug");
        ddlMonth.Items.Add("Sep");
        ddlMonth.Items.Add("Oct");
        ddlMonth.Items.Add("Nov");
        ddlMonth.Items.Add("Dec");
    }
    //********************************************************
    protected void btnUpload_Click(object sender, EventArgs e)
    {
        if (avatarUpload.HasFile)
        {
            if (checkImage(avatarUpload.FileName))
            {
                imageUpload();
                AvatarPreview(avatarUpload.FileName);
                avatarChange();
            }
        }
    }
    //********************************************************
    protected void btnUpdateAvatar_Click(object sender, EventArgs e)
    {

    }
    //********************************************************
    bool checkImage(string fileName)
    {
        string ext = Path.GetExtension(fileName);
        switch (ext)
        {
            case ".jpg":
            case ".jpeg":
            case ".gif":
            case ".png":
                return true;
            default:
                return false;
        }
    }
    //********************************************************
    void imageUpload()
    {
        string imagePath = MapPath("~/users/" + getEmail() + "/avatar/");
        avatarUpload.SaveAs(imagePath + avatarUpload.FileName);
    }
    //********************************************************
    void AvatarPreview(string image)
    {
        imgAvatarShow.ImageUrl = "~/users/" + getEmail() + "/avatar/" + image;
    }
    //********************************************************
    string getEmail()
    {
        cmd.Connection = con;
        cmd.CommandText = "select email from [users] where id = @id";
        return cmd.ExecuteScalar().ToString();
    }
    //********************************************************
    void avatarChange()
    {
        string avatarName = imgAvatarShow.ImageUrl;
        int index = avatarName.LastIndexOf("/");
        avatarName = avatarName.Substring(index + 1);

        cmd.Parameters.AddWithValue("@avatar", avatarName);
        cmd.CommandText = "update [profile] set avatar = @avatar where id = @id";
        cmd.ExecuteNonQuery();
    }
    //********************************************************
    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        cmd.Connection = con;

        //update city
        if (txtCity.Text != "")
        {
            cmd.Parameters.AddWithValue("@city", txtCity.Text);
            cmd.CommandText = "update [profile] set city = @city where id = @id";
            cmd.ExecuteNonQuery();
        }

        //update country
        if (txtCountry.Text != "")
        {
            cmd.Parameters.AddWithValue("@country", txtCountry.Text);
            cmd.CommandText = "update [profile] set country = @country where id = @id";
            cmd.ExecuteNonQuery();
        }

        //update about
        if (txtAbout.Text != "")
        {
            cmd.Parameters.AddWithValue("@about", txtAbout.Text);
            cmd.CommandText = "update [profile] set about = @about where id = @id";
            cmd.ExecuteNonQuery();
        }

        //update birthday
        string birthday = ddlYear.SelectedItem.Text + "/" + ddlMonth.SelectedItem.Text + "/" + ddlDay.SelectedItem.Text;
        cmd.Parameters.AddWithValue("@birthday", birthday);
        cmd.CommandText = "update [profile] set birthday = @birthday where id = @id";
        cmd.ExecuteNonQuery();

        //update sex
        if (rdbSex.SelectedIndex == 0)
        {
            cmd.CommandText = "update [profile] set sex = 'True' where id=@id";
            cmd.ExecuteNonQuery();
        }

        else if (rdbSex.SelectedIndex == 1)
        {
            cmd.CommandText = "update [profile] set sex = 'False' where id=@id";
            cmd.ExecuteNonQuery();
        }

        //update m
        if (rdbM.SelectedIndex == 0)
        {
            cmd.CommandText = "update [profile] set m = 'False' where id=@id";
            cmd.ExecuteNonQuery();
        }

        else if (rdbM.SelectedIndex == 1)
        {
            cmd.CommandText = "update [profile] set m = 'True' where id=@id";
            cmd.ExecuteNonQuery();
        }

        Response.Redirect("~/home.aspx");
    }
    //********************************************************
    bool chkProfile(int id)
    {
        cmd.Connection = con;
        cmd.CommandText = "SELECT COUNT(*) FROM [profile] where id = @id";

        if (cmd.ExecuteScalar().ToString() == "1")
            return true;
        else
            return false;
    }
    //********************************************************
    void SetAvatar()
    {
        if (chkProfile(Convert.ToInt32(Request.Cookies["id"].Value)))
        {
            cmd.Connection = con;
            cmd.CommandText = "select count(*) from [profile] where id = @id and avatar like '%.%'";

            if (cmd.ExecuteScalar().ToString() == "1")
            {
                cmd.CommandText = "select avatar from profile where id=@id";
                string image = cmd.ExecuteScalar().ToString();
                imgAvatarShow.ImageUrl = "~/users/" + getEmail() + "/avatar/" + image;
            }
            else
                imgAvatarShow.ImageUrl = "~/img/avatar.png";
        }
    }
    //********************************************************
    void SetBirthday()
    {
        if (chkProfile(Convert.ToInt32(Request.Cookies["id"].Value)))
        {
            cmd.Connection = con;
            cmd.CommandText = "select count(*) from [profile] where id = @id and birthday like '%/%'";

            if (cmd.ExecuteScalar().ToString() == "1")
            {
                cmd.CommandText = "select birthday from profile where id=@id";
                string birthday = cmd.ExecuteScalar().ToString();

                int first_slash = birthday.IndexOf("/");
                int last_slash = birthday.LastIndexOf("/");

                string birthday2 = birthday.Substring(first_slash + 1);

                string year = birthday.Substring(0, 4);
                string month = birthday.Substring(first_slash + 1, last_slash - first_slash - 1);
                string day = birthday.Substring(last_slash + 1);

                ddlDay.Text = day;
                ddlMonth.Text = month;
                ddlYear.Text = year;
            }
        }
    }
    //********************************************************
    
    
    
    //********************************************************
    void chkCookie()
    {
        try
        {
            if (Request.Cookies["id"].Value == null)
                Response.Redirect("~/Default.aspx");
        }
        catch
        {
            Response.Redirect("~/Default.aspx");
        }
    }
}