﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;

public partial class profile : System.Web.UI.Page
{
    SqlConnection con = new SqlConnection(@"Data Source=.\SQLEXPRESS;AttachDbFilename=|DataDirectory|\Database.mdf;Integrated Security=True;User Instance=True");
    SqlCommand cmd = new SqlCommand();
    SqlCommand cmd2 = new SqlCommand();
    PersianCalendar persian = new PersianCalendar();
    Khorshidi khorshidi = new Khorshidi();

    public int profileID;

    protected void Page_Load(object sender, EventArgs e)
    {
        //check user is logged in
        chkCookie();

        con.Open();
        getProfileId();
        ChangeTitle();
        SetAvatar();
        SetProfileInfo();

        cmd.Parameters.AddWithValue("@id", Convert.ToInt32(Request.Cookies["id"].Value));
        cmd.Parameters.AddWithValue("@follow_id", profileID);
        if (isFriend())
            btnFollow.Visible = false;

        srcTwitts.SelectParameters.Clear();
        srcTwitts.SelectParameters.Add("profileid", profileID.ToString());
    }
    //********************************************************
    void ChangeTitle()
    {
        cmd.Connection = con;
        cmd.CommandText = "select name from [users] where id = @profileID";
        cmd.Parameters.AddWithValue("@profileID", profileID);
        ltlTitile.Text = cmd.ExecuteScalar().ToString();
        ltlTitile.Text += " - نمایه";
    }
    //********************************************************
    void getProfileId()
    {
        if(Request.QueryString["profileID"] != null)
        {
            profileID = Convert.ToInt32(Request.QueryString["profileID"]);
        }
        else
        {
            cmd.Connection = con;
            cmd.CommandText = "select id from [users] where id=@id";
            cmd.Parameters.AddWithValue("@id", Convert.ToInt32(Request.Cookies["id"].Value));

            profileID = Convert.ToInt32(cmd.ExecuteScalar());
        }
    }
    //********************************************************
    void SetAvatar()
    {
        cmd.Connection = con;
        cmd.CommandText = "select count(*) from [profile] where id = @profileID and avatar like '%.%'";

        if (cmd.ExecuteScalar().ToString() == "1")
        {
            string avatar = "~/users/" + getEmail();
            cmd.CommandText = "select avatar from [profile] where id = @profileID";
            avatar += "/avatar/" + cmd.ExecuteScalar().ToString();

            imgProfileAvatar.ImageUrl = avatar;
        }
        else
        {
            imgProfileAvatar.ImageUrl = "~/img/avatar_bird.jpg";
        }
    }
    //********************************************************
    string getEmail()
    {
        cmd.Connection = con;
        cmd.CommandText = "select email from [users] where id = @profileID";
        return cmd.ExecuteScalar().ToString();
    }
    //********************************************************
    void SetProfileInfo()
    {
        if (chkProfile())
        {
            cmd.Connection = con;

            //set sex
            cmd.CommandText = "select sex from [profile] where id=@profileID";
            if (cmd.ExecuteScalar().ToString() != "")
            {
                if (cmd.ExecuteScalar().ToString() == "True")
                    lblSex.Text = "مرد ";
                else
                    lblSex.Text = "زن ";
            }
            else
            {
                lblSex.Visible = false;
            }

            //set age & birthday
            cmd.CommandText = "select birthday from [profile] where id=@profileID";

            if (cmd.ExecuteScalar().ToString() != "")
            {
                string birth = cmd.ExecuteScalar().ToString();
                string birthYear = birth.Substring(2, 2);

                string datenow = persian.GetYear(DateTime.Now).ToString();
                string yearnow = datenow.Substring(2, 2).ToString();

                int age = Convert.ToInt32(yearnow) - Convert.ToInt32(birthYear);

                lblAge.Text = age.ToString() + " ساله ";
                lblBirth.Text = "متولد " + cmd.ExecuteScalar().ToString();
            }
            else
            {
                lblAge.Visible = false;
                lblBirth.Visible = false;
            }

            //set M
            cmd.CommandText = "select m from [profile] where id=@profileID";
            if (cmd.ExecuteScalar().ToString() != "")
            {
                if (cmd.ExecuteScalar().ToString() == "True")
                    lblM.Text = "متاهل ";
                else
                    lblM.Text = "مجرد ";
            }
            else
            {
                lblM.Visible = false;
            }

            //set country and city
            cmd2.Connection = con;
            cmd.CommandText = "select country from [profile] where id = @profileID";
            cmd2.CommandText = "select city from [profile] where id=@profileID";
            cmd2.Parameters.AddWithValue("@profileID", profileID);

            if (cmd.ExecuteScalar().ToString() != "" && cmd2.ExecuteScalar().ToString() != "")
            {
                lblFrom.Text = "از " + cmd.ExecuteScalar().ToString() + " ، " + cmd2.ExecuteScalar().ToString();
            }
            else if(cmd.ExecuteScalar().ToString() != "" && cmd2.ExecuteScalar().ToString() == "")
            {
                lblFrom.Text = "از " + cmd.ExecuteScalar().ToString();
            }
            else if (cmd.ExecuteScalar().ToString() == "" && cmd2.ExecuteScalar().ToString() != "")
            {
                lblFrom.Text = "از " + cmd2.ExecuteScalar().ToString();
            }
            else
            {
                lblFrom.Visible = false;
            }

            //if user has not profile, show lblEmpty
            if (lblSex.Visible == false && lblM.Visible == false && lblFrom.Visible == false)
            {
                lblAge.Visible = false;
                lblBirth.Visible = false;
                lblEmpty.Visible = true;
            }
            else
            {
                lblEmpty.Visible = false;
            }

            //set about
            cmd.CommandText = "select about from [profile] where id=@profileID";
            if (cmd.ExecuteScalar().ToString() != "")
                lblAbout.Text = cmd.ExecuteScalar().ToString();
        }
    }
    //********************************************************
    bool chkProfile()
    {
        cmd.Connection = con;
        cmd.CommandText = "SELECT COUNT(*) FROM [profile] where id = @profileID";

        if (cmd.ExecuteScalar().ToString() == "1")
            return true;
        else
            return false;
    }
    //********************************************************
    bool isFriend()
    {
        if (profileID == Convert.ToInt32(Request.Cookies["id"].Value))
            return true;
        cmd.Connection = con;
        cmd.CommandText = "select count(*) from [follow] where user_id=@id and follow_id=@follow_id";
        if (cmd.ExecuteScalar().ToString() == "1")
            return true;
        else
            return false;
    }
    //********************************************************
    protected void btnFollow_Click(object sender, EventArgs e)
    {
        cmd.Connection = con;
        cmd.CommandText = "insert into [follow](user_id,follow_id) values(@id,@follow_id)";

        cmd.ExecuteNonQuery();
        btnFollow.Visible = false;
    }
    //********************************************************like
    protected void like(object sender, CommandEventArgs e)
    {
        string like_btn =  e.CommandName.ToString() ;
        cmd.Connection = con;
        cmd.CommandText = "insert [twitt](Like_twitt) values(@reply_text)";

        string reply_text2 = like_btn;

        

        cmd.Parameters.AddWithValue("@Like_twitt",TextBox1 .Text.ToString ()+1);
        

        cmd.ExecuteNonQuery();

        
    }


    //********************************************************
    protected void btnDelete_Click(object sender, ImageClickEventArgs e)
    {
        ImageButton button = (ImageButton)sender;
        string id = button.AlternateText;
        srcTwitts.DeleteParameters.Add("deleteID", id);
        srcTwitts.Delete();
    }
    //********************************************************
    protected void btnReply_Click(object sender, CommandEventArgs e)
    {
        string name = "<b>" + " Answer of " + e.CommandName.ToString() + " : " + "</b>";
        cmd.Connection = con;
        cmd.CommandText = "insert [twitt](text,user_id,date,time) values(@reply_text,@id,@date,@time)";

        string reply_text = name;

        foreach (RepeaterItem item in Repeater1.Items)
        {
            TextBox txtReply = (TextBox)item.FindControl("txtReply");
            if (txtReply != null)
            {
                reply_text += txtReply.Text;
            }
        }

        cmd.Parameters.AddWithValue("@reply_text", reply_text);
        cmd.Parameters.AddWithValue("@date", khorshidi.Now);
        cmd.Parameters.AddWithValue("@time", DateTime.Now.Hour.ToString());

        cmd.ExecuteNonQuery();

        foreach (RepeaterItem item in Repeater1.Items)
        {
            TextBox txtReply = (TextBox)item.FindControl("txtReply");
            if (txtReply != null)
            {
                txtReply.Text = "";
            }
        }
    }

    //********************************************************
    void chkCookie()
    {
        try
        {
            if (Request.Cookies["id"].Value == null)
                Response.Redirect("~/Default.aspx");
        }
        catch
        {
            Response.Redirect("~/Default.aspx");
        }
    }
}